<?php

class AdapterFeature
{
	public $supportExp = 0;
	public $supportPM = 0;
	public $supportEncl = 1;
	public $supportDG = 0;
	public $supportMediaPatrol = 0;
	public $supportMigrate = 0;
	public $isThor = 0;
	public $isOdin = 0;
	public $isOdin2 = 0;
	public $isLoki = 0;
	public $canSetCreateSize = 0;
	public $supportMuiltBgaRate = 0;
	public $supportCopyback = 0;
	public $supportFirmware = 0;
	public $supportBIOSVersion = 0;
	public $supportForegroundInit = 0;
	public $supportSetDedicatedPD = 0;
	public $supportOptimizeCpuEfficiency = 0;
	public $supportAdvancedNameLength = 1;
	public $supportDownloadBIOS = 0;
	public $supportAdaptiveCache = 0;
	public $supportImportVD = 0;
	
	private function __construct(){}
	
	public static function getInstance($id = 0)
	{
		$instance = new AdapterFeature();
		
		$hbaInfo = HBAFactory::getInstance($id);
		
		if (! $hbaInfo) {
			return;
		}
		
		$instance->supportExp =  $hbaInfo->getMaxExpander();		
		$instance->supportPM = $hbaInfo->getMaxPM();		
		$instance->supportDG =  $hbaInfo->getDiskGroupSupport();
		if ($instance->supportDG) 
			$instance->supportSetDedicatedPD=1;
		
		if(($hbaInfo->getDevID() != 0)){
			$ID = dechex($hbaInfo->getDevID());
			//Thor 61
			//Odin 6320 6440 OdinII 6480
			//Loki 8480
			$prefix = intval(substr($ID, 0, 2));
			$postfix = intval(substr($ID, 2, 2));
			if( $prefix ==  61){
				$instance->isThor = 1;
			} else if ($prefix >= 63 && $prefix <= 64) {
				$instance->isOdin = 1;
				if ($postfix >= 80) {
					$instance->isOdin2 = 1;
				}
			} else if ($prefix >= 81) {
				$instance->isLoki = 1;
			}
			
			if ($prefix < 64) {
				$instance->canSetCreateSize = 1;
			}
			
			if ($instance->isThor) {
				$instance->supportAdvancedNameLength = 0;
			}
			
			if ($instance->isOdin2 || $instance->isLoki) {
				$instance->supportMuiltBgaRate = 1;
			}

			if ($instance->isOdin) {
				$instance->supportOptimizeCpuEfficiency = 1;
				$instance->supportBIOSVersion = 1;
				$instance->supportDownloadBIOS = 1;
			}
			
			if ($instance->isLoki) {
				$instance->supportAdaptiveCache = 1;
				$instance->supportCopyback = 1;
				$instance->supportFirmware = 1;
				$instance->supportImportVD = 1;
			}
		}
		
		if ($hbaInfo->supportMediaPatrol()) {
			$instance->supportMediaPatrol = 1;
		}
		
		if ($hbaInfo->supportMigration()) {
			$instance->supportMigrate = 1;
		}
        
		if ($hbaInfo->supportForegroundInit()) {
			$instance->supportForegroundInit = 1;
		}
		
		return $instance;
	}
	
	public function isSupportExp()
	{
		return $this->supportExp;
	}
	
	public function isSupportPM()
	{
		return $this->supportPM;
	}
	
	public function isSupportEncl()
	{
		return $this->supportEncl;
	}
	
	public function isSupportDG()
	{
		return $this->supportDG;
	}
	
	public function isSupportMediaPatrol()
	{
		return $this->supportMediaPatrol;
	}
	
	public function isSupportMigrate()
	{
		return $this->supportMigrate;
	}
	
	public function isThor()
	{
		return $this->isThor;
	}
}

class HBAFactory
{
	private static $instances = array();
	
	public static function getInstance($id = 0)
	{
		if (! sizeof(self::$instances)) {
			self::initialze();
		}
		
		if (isset(self::$instances[$id])) {
			return self::$instances[$id];
		}
		else 
			return false;
	}
	
	private static function initialze()
	{
		//initialze it
		$HBAList = new HBAList();
		$HBAList->toGetHBAInfo();
		$HBAList->initData();
		
		$HBAs = $HBAList->getBaseClasses();
		
		foreach ($HBAs as $hba)
		{
			self::$instances[$hba->getDeviceID()] = $hba;
		}
	}
	
	public static function getAllInstance()
	{
		if (! sizeof(self::$instances)) {
			self::initialze();
		}
		
		return self::$instances;
	}
}

?>