<?php
class ActionMediaPatrolPD extends UserAction 
{
	private $HD_IDs;
	private $Action;
	
	private $freeNotSpareHDIDs = array();
	
	protected function validatePara()
	{
		//check the http request parameters
	}
	protected function initActionPara()
	{
		$this->HD_IDs = getRequestPara("HDs");
		$this->Action = getRequestPara("action");
	}
	
	private function doMediaPatrolPD()
	{
		$failNum = 0;
		$failMsg = '';
		
		#set id of pd disks in target vd
		#set to array
		$MP_HDIDs = array();
		$MP_HDs = explode(" ",$this->HD_IDs);
		foreach ($MP_HDs as $HDID)
		{
			if (trim($HDID) != "") {
				$MP_HDIDs[] = $HDID;
			}
		}
		
		#do mp for each pd
		foreach ($MP_HDIDs as $Hd)
		{
			$isFreeNotSpare = false;
			foreach ($this->freeNotSpareHDIDs as $HDID)
			{
				if ($HDID == intval($Hd)) {
					$isFreeNotSpare = true;
					break;
				}
			}
			
			if ($isFreeNotSpare 
				&&
				( $this->Action == BgaControl::BGA_CONTROL_START
				|| $this->Action == BgaControl::BGA_CONTROL_RESTART
				)) {
				#free pd can not do mp
				$failNum++;
				$err = gettext(AlertMsg::MP_FREE_PD_ERROR);
				$failMsg .= "PD ".$Hd.": ".$err. "\n";
			}
			else 
			{
				#do mp
				$this->ApiCmd = new XMLAPICommand();
				$this->ApiCmd->setCommand(XMLAPICommand::MV_PD_HDMPCheck);
				$this->ApiCmd->setCommandPara("AdapterID",$this->getAdapterID());
				$this->ApiCmd->setCommandPara("HD_ID",$Hd);
				$bgaAction = BgaControl::getBgaControlValue($this->Action);
				$this->ApiCmd->setCommandPara("Action",$bgaAction);
				$this->ApiCmd->issueCommand();
				
				if ($this->ApiCmd->getResult()->RetVal . "") {
					$failNum++;
					$err = ComError::getErrStr(intval($this->ApiCmd->getResult()->RetVal));
					$err = gettext($err);
					$failMsg .= "PD ".$Hd.": ".$err. "\n";
				}
			}
		}
		
		
		if($failNum > 0)
		{
			$this->setHDMPCmdXmlRetFail($failMsg);
		}
		else {
			$this->setHDCmdXmlRetSuccess();
		}
	}
		
	private function setHDMPCmdXmlRetFail($failMsg)
	{
		$this->xmlRet = new FailXMLRet();
		$this->xmlRet->Msg = $failMsg;
		$this->xmlRet->Url = getBaseURL()
			. "JumpPage.php?Target=" . Target::getHdDetail . "&ID=" . $this->HD_IDs . "&HBAID=" . $this->getAdapterID();
	}
	
	#free disk can not do mp
	private function setfreeNotSpareHDIDs()
	{
		include_once("../phpsrc/baseclass/Device.class.php");
		include_once("../phpsrc/baseclass/SASDevice.class.php");
		include_once("../phpsrc/baseclass/DeviceFactory.class.php");
		include_once("../phpsrc/baseclass/PortDevice.class.php");
		include_once("../phpsrc/baseclass/Block.class.php");
		include_once("../phpsrc/baseclass/HD.class.php");
		include_once("../phpsrc/baseclass/PM.class.php");
		include_once("../phpsrc/baseclass/ExpanderDevice.class.php");

		include_once("../phpsrc/baseclass/HdList.class.php");
		
		$HdList = new HdList();
		$HdList->setAdapterID($this->getAdapterID());
		$HdList->toGetHdFreeInfo();
		$HdList->toGetHDRaidStatus();
		
		$HDs = $HdList->getBaseClasses();
		
		foreach ($HDs as $HD)
		{
			if ($HD->isFree() && !$HD->isSpare()) {
				$this->freeNotSpareHDIDs[] = trim($HD->getDeviceID());
			}
		}
	}
	
	protected function doAction()
	{
		$this->setfreeNotSpareHDIDs();
		$this->doMediaPatrolPD();
	}
}
?>