<?php
abstract class EnclBase extends BaseFactory 
{
	const ENC_SIMULATOR_ID = "AIR";
	public function toGetEnclExpanderInfo()
	{
		$expList = new ExpanderList();
		$expList->setAdapterID($this->getAdapterID());
		$expList->toGetExpInfo();
		foreach ($expList->getBaseClasses() as $exp)
		{
			//if there is no enclosure ID related
			if ($exp->getEnclosureID() == 65535) 
			{
				$this->addExpanderToAirEnc($exp);
			}
			else
			{
				$notfound = true;
				foreach ($this->BaseClasses as $enc)
				{
					if ($exp->getEnclosureID() == $enc->getDeviceID()) {
						$enc->addExpander($exp);
						$notfound = false;
						break;
					}
				}
				
				//in case there is no enclosure but expander's enclosure id is 0
				if($notfound)
				{
					$this->addExpanderToAirEnc($exp);
				}
			}
		}
	}
	
	public function toGetEnclPMInfo()
	{
		//
		$pmList = new PMList();
		$pmList->setAdapterID($this->getAdapterID());
		$pmList->toGetPMInfo();
		foreach ($pmList->getBaseClasses() as $pm)
		{
			//
			if ($pm->getEnclosureID() == 65535)  {
				$this->addPMToAirEnc($pm);
			}
			else{
				$notfound = true;
				foreach ($this->BaseClasses as $enc)
				{
					if ($pm->getEnclosureID() == $enc->getDeviceID()) {
						$enc->addPM($pm);
						$notfound = false;
						break;
					}
				}
				
				//in case there is no enclosure but pm's enclosure id is 0
				if($notfound)
				{
					$this->addPMToAirEnc($exp);
				}
			}
		}
	}
	
	public function toGetEnclInfo()
	{
		//
		$handler = new EncInfoXmlHandler();
		$this->runCommand(XMLAPICommand::MV_ENC_GetEnclosureInfo, $handler);
	}
	
	public function addExpanderToAirEnc($exp)
	{
		$Air_Encl = null;
		$notfound = true;
		foreach ($this->BaseClasses as $enc)
		{
			if ($enc->getProductId() == "AIR") {
				$Air_Encl = $enc;				
				$notfound = false;
				break;
			}
		}
		
		if ($notfound) {
			$Air_Encl = $this->addAirEnc();
		}
		
		$Air_Encl->addExpander($exp);
	}
	
	public function addAirEnc()
	{
		$Air_Encl = new Encl();
		$Port = new PortDevice();
		$Air_Encl->setParentDevice($Port);			
		$Air_Encl->setStatus(ENCStatus::ENC_STATUS_OK);
		$Air_Encl->setVendorId("AIR");
		$Air_Encl->setProductId("AIR");
		$Air_Encl->setProductRevision("AIR");
		$Air_Encl->setDeviceID(self::ENC_SIMULATOR_ID);
		
		$this->BaseClasses[$Air_Encl->getDeviceID()] = $Air_Encl;
		
		return $Air_Encl;
	}
	
	public function addPMToAirEnc($pm)
	{
		$Air_Encl = null;
		$notfound = true;
		foreach ($this->BaseClasses as $enc)
		{
			if ($Encl->getProductId() == "AIR") {
				$Air_Encl = $enc;				
				$notfound = false;
				break;
			}
		}
		
		if ($notfound) {
			$Air_Encl = $this->addAirEnc();
		}
		
		$Air_Encl->addPM($pm);
	}
	
	protected function createObject()
	{
		return new Encl();
	}
}

?>