<?php
class EventList extends BaseData
{
	//const default_len = 4;
	private $StartNo;
	private $EventNum;
	private $EventMaxNum;
	
	public function setStartNo($startNo)
	{
		$this->StartNo = $startNo;
	}
	
	public static function GetMaxEventNum()
	{
		if (parent::DebugTest) {
			return 40;
		}
		
		$XMLApiCmd = new XMLAPICommand();
		$XMLApiCmd->setCommand(XMLAPICommand::ZA_MV_EVT_GetEvents);
		$XMLApiCmd->setCommandPara("Num", "0");// 0 stand for get event start no and end no
		$XMLApiCmd->setCommandPara("Start", "0");
		$XMLApiCmd->setCommandPara("End", "0");
	
		if ($XMLApiCmd->issueCommand()) {
			$XMLRoot = $XMLApiCmd->getResult();
			return $XMLRoot->n;
		}
		
		return 0;
	}
	
	/*   The StartNo >= 0 and <=$MaxNo - $len + 1   */
	public function checkPara()
	{
		$max = self::GetMaxEventNum();
		if ($max == 0) {
			$this->StartNo = 0;
			$this->EventNum = 0;
			return;
		}
		
		$this->EventMaxNum = $max;
		
		$MaxNo = $this->EventMaxNum - 1; //get event Latest Event NO
		
		if ($this->StartNo == -1 or $this->StartNo + $this->EventNum > $MaxNo) {
			$this->StartNo = $MaxNo - $this->EventNum + 1;
		}
		if ($this->StartNo < 0) {
			$this->StartNo = 0;
		}
	}
	
	public function getEventMaxNum()
	{
		return $this->EventMaxNum;
	}
	
	public function getStartNo()
	{
		return $this->StartNo;
	}
	
	public function setEventNum($EventNum)
	{
		$this->EventNum = $EventNum;
	}
	
	public function prepareAPICommands()
	{
		$this->checkPara();
		
		$XMLApiCmd = new XMLAPICommand();
		$XMLApiCmd->setCommand(XMLAPICommand::ZA_MV_EVT_GetEvents);
		$StartNo = $this->StartNo;
		
		if ($StartNo < 0 || $StartNo === null) {
			$StartNo = 0;
		}
		$EndNo = $StartNo + $this->EventNum -1;
		//$this->
		$XMLApiCmd->setCommandPara("Num", $this->EventNum ."");
		$XMLApiCmd->setCommandPara("Start", $StartNo . "");
		$XMLApiCmd->setCommandPara("End", $EndNo . "");
		
		$this->XMLAPICommandList['setEventToBaseClass'] = $XMLApiCmd;
	}
	
	protected function setEventToBaseClass($data)
	{
		$XMLRoot = $data;
		if (isset($XMLRoot->Event)) {
			foreach ($XMLRoot->Event as $EventInfo)
			{
				$evt = new Event();
				$evt->setEventInfo($EventInfo);
				$this->BaseClasses[] = $evt;
			}
		}
	}
	
	public function setDataToBaseClass()
	{
		
	}
	
	public function loadTestData()
	{
		$Path = "../phpsrc/baseclass/testdata/eventlist/";
		$Files = array("ZA_MV_EVT_GetEvents10_14_25.xml");
		
		$this->EventMaxNum = self::GetMaxEventNum();
		$this->checkPara();
		
		foreach ($Files as $File)
		{
			$data = simplexml_load_file($Path . $File);
			$this->setEventToBaseClass($data);
		}
	}
}

?>