<?php

abstract class LdBase  extends BaseFactory
{
	public function toGetLDInfo()
	{
		$handler = new LdInfoXmlHandler();
		$this->runCommand(XMLAPICommand::MV_LD_GetInfo, $handler);
	}
	
	public function toGetLDStatus()
	{
		$handler = new LdStatusXmlHandler();
		$this->runCommand(XMLAPICommand::MV_LD_GetStatus, $handler);		
	}	
	
	public function toGetLDConfig()
	{		
		$handler = new LdConfigXmlHandler();
		$this->runCommand(XMLAPICommand::MV_LD_GetConfig, $handler);
	}
	
	public function toGetBlockInfo()
	{
		$blkList = new BlockList();
		$blkList->setAdapterID($this->getAdapterID());
		$blkList->toGetBlkInfo();
		
		foreach ($this->BaseClasses as $LD)
		{
			$blkIds = $LD->getBlockIDList();
			foreach ($blkIds as $id)
			{
				$LD->addBlock($blkList->getObj($id));
			}
		}
	}
	
	public function toGetHDInfo()
	{
		$hdList = new HdList();
		$hdList->setAdapterID($this->getAdapterID());
		$hdList->toGetHDInfo();
		
		foreach ($this->BaseClasses as $LD)
		{
			$blks = $LD->getBlockList();
			
			foreach ($blks as $blk)
			{
				$blk->linkHD($hdList->getObj($blk->getHDID()));
			}
		}
	}
	
	protected function createObject()
	{
		return new LD();
	}
}

?>