<?php

//include_once("Container.class.php");
//include_once("../phpsrc/command/CmdGetEventMaxNo.class.php");

class Evt
{
	public $Class;
	public $Code;
	public $Severity;
	public $AdapterID;
	public $SeverityImg;
	public $SeverityTitle;
	public $Date;
	public $Log;

	public function setEvt($Event)
	{
		$this->Class = $Event->getClass();
		$this->Code = $Event->getCode();
		$this->Severity = $Event->getSeverity();
		$this->AdapterID = $Event->getAdapterID();
		$this->Date = $Event->getTime();
		$this->Log = $Event->getEvtLog();
		
		$this->SeverityImg = EventSeverity::getSeverityImg($Event->getSeverity());
		$this->SeverityTitle = EventSeverity::getSeverityTitle($Event->getSeverity());
		$this->SeverityTitle = gettext($this->SeverityTitle);
	}
	
	public function convertWords()
	{
	
		$logValues = explode("|",$this->Log);
		$logStr = gettext(EventMsg::getEventStr($logValues[0])); //$Event Code
		
		//[event_code,Severity,arg1,arg2,....] to [,arg1,arg2,....]
		$argsValues = array_splice($logValues,2);
		
		/*convert args*/
		/*replace %n with args[n]*/
		$i = 1;
		foreach ($argsValues as $Arg)
		{
			if (strpos($logStr,"%" . $i) !== false) {
				$logStr	= str_replace("%" . $i, $Arg, $logStr);
				$i++;
			}
			else 
			{
				break;
			}
		}
		
		//filter out more %
		$offset = 0;
		while ( ($i = strpos($logStr,'%',$offset)) !== false) {
			if (ord(substr($logStr,$i+1)) > 48 
				&& ord(substr($logStr,$i+1)) <= 57) {
				$logStr = substr($logStr,0,$i) . substr($logStr,$i+2);
			}
			else {
				$offset++;
			}
		}

		$this->Log = $logStr;
		
		//need to convert time.
		
		$this->Class = gettext(EventClass::getEventClassStr($this->Class));
	}
	
}

class CtnEventList extends Container
{
	const default_len = 20;
	private $StartNo;
	private $EventNum;
	private $EventMaxNum;
	
	protected function setBase()
	{
		$this->base = new EventList();
		
		$this->base->setStartNo($this->StartNo);
		
		if (!$this->EventNum) {
			$this->base->setEventNum(self::default_len);
		}
		else 
		{
			$this->base->setEventNum($this->EventNum);
		}
	}
	
	public function setStartNo($startNo)
	{
		$this->StartNo = $startNo;
	}
	
	public function getStartNo()
	{
		return $this->StartNo;
	}
	
	public function setEventNum($EventNum)
	{
		$this->EventNum = $EventNum;
	}
	
	protected function setDataToPage()
	{
		$EventList = array();
		$bases = $this->base->getBaseClasses();
		foreach ($bases as $Event)
		{
			$evt = new Evt();
			$evt->setEvt($Event);
			$evt->convertWords();
			
			$EventList[] = $evt;
		}
		//display xml
		
		$EventList = array_reverse($EventList);
		$this->StartNo = $this->base->getStartNo();
		$this->EventNum = sizeof($EventList);
		$this->EventMaxNum = $this->base->getEventMaxNum();
		if ($EventList) {
			$StartID = $this->StartNo + 1;
			$EndID = $this->StartNo + $this->EventNum;
			if ($EndID > $this->EventMaxNum) {
				$EndID = $this->EventMaxNum;
			}
			$this->smarty->assign("EventMaxNum",$this->EventMaxNum);
		}
		else {
			$StartID = 0;
			$EndID = 0;
			$this->EventMaxNum = 0;
		}
		$this->smarty->assign("EventList",$EventList);
		$this->smarty->assign("StartID",$StartID);
		$this->smarty->assign("EndID", $EndID);
		$this->smarty->assign("EventMaxNum",$this->EventMaxNum);
		
	}	
	public function displayXML()
	{
		$this->display("XML_EventList.tpl");
	}
}

class CtnAllEventList
{
	const EVENTLIST_MAX_NUM = 100; //the XML doc buffer of zraidapi can contain 100 Events xml Elements 
	
	private $allEvents = array();
	private $startNo = 0;
	
	public function getAllEvents()
	{
		return $this->allEvents;
	}
	
	public function setStartNo($startNo)
	{
		$this->startNo = $startNo;
	}
	
	public function smartyAssign($smarty)
	{
		$this->smarty = $smarty;
	}
	
	protected function initBases()
	{
		$eventMaxNum = EventList::GetMaxEventNum();
		
		$this->base = array();
		
		for ($i = $this->startNo; $i < $eventMaxNum; $i = $i + self::EVENTLIST_MAX_NUM)
		{
			$evtList = new EventList();
			$evtList->setStartNo($i);
			if ($i + self::EVENTLIST_MAX_NUM > $eventMaxNum) 
			{
				$evtList->setEventNum($eventMaxNum - $i);
			}
			else 
			{
				$evtList->setEventNum(self::EVENTLIST_MAX_NUM);
			}
			
			$this->base[] = $evtList;
		}
	}
	
	private function setDataFromBase()
	{
		$this->allEvents = array();
		foreach ($this->base as $evtList)
		{
			$events = array();
			$bases = $evtList->getBaseClasses();
			foreach ($bases as $Event)
			{
				$evt = new Evt();
				$evt->setEvt($Event);
				$evt->convertWords();
				
				$events[] = $evt;
			}
			$this->allEvents = array_merge($this->allEvents,$events);
		}
		$this->allEvents = array_reverse($this->allEvents);
	}
	
	protected function saveDataToPage()
	{
		$this->smarty->assign("EventList",$this->allEvents);
	}
	
	public function initData()
	{
		$this->initBases();
		foreach ($this->base as $evtList)
		{
			$evtList->initData();
		}
		$this->setDataFromBase();
	}
		
	//over ride the base class' initContainer() method
	public function initContainer()
	{
		$this->initBases();
		foreach ($this->base as $evtList)
		{
			$evtList->initData();
		}
		$this->setDataFromBase();
		$this->saveDataToPage();
	}
	
	protected function displayXML()
	{
		$this->display("EventsSaveFilePage.tpl");
	}
}

?>