<?php
class HBAInfo extends VO 
{
	public $ID;
	public $DriverVersion;
	public $BIOSVersion;
	public $FirmwareVersion;
	public $BootLoaderVersion;
	public $SystemIOBusNumber;
	public $SlotNumber;
	
	public $VenID;
	public $SubVenID;
	public $DevID;
	public $SubDevID;
	
	public $RevisionID;
	
	public $InterruptLevel;
	public $InterruptVector;
	public $MaxPDPerVD;
	public $MaxPDPerDG;
	public $MaxVDPerDG;
	public $PortCount;
	public $PortSupportType;
	public $Features;
	public $AlarmSupport;
//	public $RAMSupport;
	public $MaxBlockPerPD;
	public $MaxHD;
	public $MaxExpander;
	public $MaxPM;
	public $MaxLogicalDrive;
	public $LogicalDriverMode;
	public $DiskGroupSupport;
	
	public $supportRAID;
	public $isSupportRAID5;
	
	//details
	public $AlarmOn;
	public $AutoRebuildOn;
	public $BGARate;
	public $MPRate = 1;
	public $PollSMARTOn = 0;
	//public $SuspendMode = 0;
	public $InterruptCoalescing;
	
	public $isOdin = 0;
	
	//added 3-19
	public $CopyBack; 
	public $SyncRate; 
	public $InitRate; 
	public $RebuildRate; 
	public $MigrationRate; 
	public $CopybackRate; 
	
	public $AdvancedFeatures;
	
	
	public function setHBAInfo($HBA)
	{
		$this->ID = $HBA->getDeviceID();
		$this->DriverVersion = $HBA->getDriverVersion();
		$this->BIOSVersion = $HBA->getBIOSVersion();
		$this->FirmwareVersion = $HBA->getFirmwareVersion();
		$this->BootLoaderVersion = $HBA->getBootLoaderVersion();
		$this->SystemIOBusNumber = $HBA->getSystemIOBusNumber();
		$this->SlotNumber = $HBA->getSlotNumber();
		
		$this->VenID = strtoupper(dechex($HBA->getVenID()));
		$this->SubVenID = strtoupper(dechex($HBA->getSubVenID()));
		$this->DevID = strtoupper(dechex($HBA->getDevID()));
		$this->SubDevID = strtoupper(dechex($HBA->getSubDevID()));
		
		$this->RevisionID = strtoupper(dechex($HBA->getRevisionID()));
		$this->InterruptLevel = $HBA->getInterruptLevel();
		$this->InterruptVector = $HBA->getInterruptVector();
		
		$this->MaxPDPerVD = $HBA->getMaxPDPerVD();
		$this->MaxPDPerDG = $HBA->getMaxPDPerDG();
		$this->MaxVDPerDG = $HBA->getMaxVDPerDG();
		
		$this->PortCount = $HBA->getPortCount();
		$this->PortSupportType = $HBA->getPortSupportType();
		$this->Features = $HBA->getFeatures();
		$this->AlarmSupport = $HBA->getAlarmSupport();
		
		//$this->RAMSupport = $HBA->getRAMSupport();
		$this->MaxBlockPerPD = $HBA->getMaxBlockPerPD();
		$this->MaxHD = $HBA->getMaxHD();
		$this->MaxExpander = $HBA->getMaxExpander();
		$this->MaxPM = $HBA->getMaxPM();
		$this->MaxLogicalDrive = $HBA->getMaxLogicalDrive();
		$this->LogicalDriverMode = $HBA->getLogicalDriverMode();
		$this->DiskGroupSupport = $HBA->getDiskGroupSupport();		
		
		$this->supportRAID = $HBA->supportRAID();
		$this->isSupportRAID5 = $HBA->supportLDRaid5();
		$this->isOdin = $HBA->getMaxExpander() != 0 ? 1 : 0;
		
		$this->AdvancedFeatures = $HBA->getAdvancedFeatures();
	}
	
	public function setHBADtl($HBA)
	{
		//config
		$this->AlarmSupport = $HBA->getAlarmSupport();
		$this->AlarmOn = $HBA->isAlarmOn();
		$this->AutoRebuildOn = $HBA->isAutoRebuildOn();
		$this->PollSMARTOn = $HBA->isPollSMARTOn();
		//$this->BGARate = BGARate::RateToPercentage($HBA->getBGARate());
		$this->BGARate =$HBA->getBGARate();
		$this->InterruptCoalescing = $HBA->getInterruptCoalescing();
		
		//added 3-19 for 4 rate		
		$this->SyncRate =$HBA->getSyncRate();
		$this->InitRate =$HBA->getInitRate();
		$this->RebuildRate =$HBA->getRebuildRate();
		$this->MigrationRate =$HBA->getMigrationRate();

		$this->CopyBack =$HBA->getCopyBack();
		$this->CopybackRate =$HBA->getCopybackRate();
		//bga rate is the same as MP rate
		/*
		if ($HBA->getMediaPatrolRate() == null) 
		{
			$this->MPRate = 1;
		}
		else 
		{
			$this->MPRate = $HBA->getMediaPatrolRate();
		}
		*/
		//$this->SuspendMode  = $HBA->isSuspendModeOn();
	}
}
?>