<?php
class TreeImg
{
	const System = "System.gif";
	const Adapter = "Adapter_icon.gif";
	const Enclosure = "Enclosure.gif";
	const BBU = "BBU.gif";
}

class CtnTreeDisplayer extends CtnDisplayer {
	private $reqParams;

	protected function initPage(){
		$params = getRequestPara('reqNodes');
		
		if (trim($params) == "") {
			$params == "0_0_1|0_2_1|1_2_1";
		}
		
		$this->reqParams = split('\|', trim($params));
		
		include_once("../phpsrc/MRUTree.php");
		$this->generateTree();
		
//		$subPage = "";
		
//		$notNeed = array("Target", "reqNodes", "UserID", "PHPSESSID", "ra");
//		
//		foreach ($_REQUEST as $key => $val)
//		{	
//			if (! in_array($key, $notNeed)) {
//				if ($key == "targetPara") {
//					$subPage .= "Target=" . $val;
//					continue;
//				}
//				else 
//				{
//					$subPage .= "&" . $key . "=" . $val;
//				}
//			}
//		}
		
//		$this->smarty->assign("subPage", $_COOKIE["SubPageUrl"]);
		
		$this->setPageName("XML_Tree.tpl");
	}
	
	protected function getID($type, $id)
	{
		return $type * 10 + $id;
	}
	
	private function setNodeExpandInfo($mruNode)
	{
		$id = $mruNode->getID();
		$type = $mruNode->getNodeType();
		$exp = EXPAND_TYPE_UNEXPAND;
		
		
		if($type == MRUTreeNodeType::ENC_LEAF 
			|| $type == MRUTreeNodeType::HD_LEAF 
			|| $type == MRUTreeNodeType::HDONARRAY_LEAF
			|| $type == MRUTreeNodeType::VDONARRAY_LEAF
			//|| $type == MRUTreeNodeType::VD_LEAF
			|| $type == MRUTreeNodeType::HDONVD_LEAF
			|| $type == MRUTreeNodeType::BBU_LEAF
		)
		{
			$exp = EXPAND_TYPE_CANNOTEXPAND;
		}else if(trim(getRequestPara('reqNodes')) == "")
		{
			$exp = EXPAND_TYPE_EXPAND;
		}
		else{
			foreach ($this->reqParams as $nodeInfo)
			{
				if(trim($nodeInfo) == "")
				{
					continue;
				}
				list($nid, $ntype, $nexpand) = split("_", $nodeInfo);
				if ($nid == $id && $ntype == $type) {
					$exp = $nexpand;
					break;
				}
			}
		}
		
		switch ($exp)
		{
			case EXPAND_TYPE_EXPAND: 
				$mruNode->expand();
				break;
			case EXPAND_TYPE_UNEXPAND:
				$mruNode->unExpand();
				break;
			case EXPAND_TYPE_CANNOTEXPAND:
				$mruNode->cannotExpand();
				break;
			default:
				//do nothing
		}
	}
	
	private function generateDG($hbaid,$adpNode)
	{
		$smarty = $this->smarty;
		
		$ctnDgList = new CtnDgList();		
		$ctnDgList->setAdapterID($hbaid);
		$ctnDgList->toGetDGInfo();
		$ctnDgList->smartyAssign($smarty);
		$ctnDgList->initContainer();
		
		$dglist = $ctnDgList->getInfos();
			
//		$dgsNode =
//			new MRUTreeNode("", "Arrays", "tip", "", 0, MRUTreeNodeType::ARRAY_TITLE_LEAF);
//		$this->setNodeExpandInfo($dgsNode);
//		if (!$dglist) {
//			$dgsNode->cannotExpand();
//		}
//		$adpNode->addChild($dgsNode);
		
		foreach ($dglist as $dg)
		{
			$id = $dg->ID;
			$name = $dg->Name;
			$dgNode = 
				new MRUTreeNode($dg->DGImg, "Array" . " ". $id . ": (" . $name . ")", "tip", 
				$this->getDetailUrl(Target::getArraySubPage . "&ID=" . $id . "&HBAID=" . $hbaid), $id,
				MRUTreeNodeType::ARRAY_LEAF,$hbaid);
			$this->setNodeExpandInfo($dgNode);
			//$dgsNode->addChild($dgNode);
			$adpNode->addChild($dgNode);
			
//			$vdsNode = new MRUTreeNode("", "Virtual Disks", "tip", "", 0,
//				MRUTreeNodeType::VDONARRAY_TITLE_LEAF);
//			$this->setNodeExpandInfo($vdsNode);
//			if (! $dg->LDList) {
//				$vdsNode->cannotExpand();
//			}
//			$dgNode->addChild($vdsNode);
//			if ($vdsNode->getExpandTypeIndex() == EXPAND_TYPE_EXPAND) {
				foreach ($dg->LDList as $vd)
				{
					$vdid = $vd->ID;
					$vdname = $vd->Name;
					$vdNode = new MRUTreeNode($vd->LDImg, "Virtual Disk" . " ". $vdid . ": (" . $vdname . ")",
						 "tip",$this->getDetailUrl(Target::getVDSubPage . "&ID=" . $vdid . "&HBAID=" . $hbaid), $vdid,
						MRUTreeNodeType::VDONARRAY_LEAF,$hbaid);
					$this->setNodeExpandInfo($vdNode);
					$dgNode->addChild($vdNode);
					//$vdsNode->addChild($vdNode);
				}
//			}		

			$hdsNode = new MRUTreeNode("", "Physical Disks", "tip", "", $id,
				MRUTreeNodeType::HDONARRAY_TITLE_LEAF,$hbaid);
			$this->setNodeExpandInfo($hdsNode);
			$IDs = array();
			$hdList = array();
			$tempList = array_merge($dg->HDList, $dg->spareHDList);
			foreach ($tempList as $HD)
			{
				if (! in_array($HD->ID, $IDs)) {
					$hdList[] = $HD;
					$IDs[] = $HD->ID;
				}
			}
			
			if (! $hdList) {
				$hdsNode->cannotExpand();
			}
			else 
			{
				//in case previous state is no HD
				if ($hdsNode->getExpandTypeIndex() == EXPAND_TYPE_CANNOTEXPAND) {
					$hdsNode->expand();
				}
			}
			$dgNode->addChild($hdsNode);
			if ($hdsNode->getExpandTypeIndex() == EXPAND_TYPE_EXPAND) {				
				foreach ($hdList as $hd)
				{
					$pdid = $hd->ID;
					$hdNode = new MRUTreeNode($hd->HDImg, "Physical Disk" . " ". $pdid, "tip",
						$this->getDetailUrl(Target::getHdDetail . "&ID=" . $pdid . "&HBAID=" . $hbaid), $pdid,
						MRUTreeNodeType::HDONARRAY_LEAF,$hbaid);
					$this->setNodeExpandInfo($hdNode);
					$hdsNode->addChild($hdNode);
				}
			}
		}
	}
	
	private function generateForeignVD($hbaid, $adpNode)
	{
		$smarty = $this->smarty;
		
		$vdList = new CtnLDList();
		$vdList->setAdapterID($hbaid);
		$vdList->toGetLDInfo();
		$vdList->toGetLDStatus();
		$vdList->toGetBlockInfo();
		$vdList->toGetHDInfo();
		$vdList->smartyAssign($smarty);
		$vdList->initContainer();
		$allvds = $vdList->getInfos();
		
		$vdsForeign = array();
		foreach ($allvds as $vd)
		{
			if($vd->AdapterID == $hbaid && ($vd->isForeign || $vd->isImportable || $vd->isNotImportable))
			{
				$vdsForeign[] = $vd;
			}
		}
		if (sizeof($vdsForeign)) {
			$vdsNotOnDgNode = new MRUTreeNode("", "Foreign Virtual Disks", "tip", "", $hbaid,
				MRUTreeNodeType::VDONARRAY_TITLE_LEAF,$hbaid); //?
			$this->setNodeExpandInfo($vdsNotOnDgNode);
			if (! $vdsForeign) {
				$vdsNotOnDgNode->cannotExpand();
			}
			else 
			{
				//
				if ($vdsNotOnDgNode->getExpandTypeIndex() == EXPAND_TYPE_CANNOTEXPAND) {
					$vdsNotOnDgNode->expand();
				}
			}
			$adpNode->addChild($vdsNotOnDgNode);
			if ($vdsNotOnDgNode->getExpandTypeIndex() == EXPAND_TYPE_EXPAND) {
				foreach ($vdsForeign as $vd)
				{
					$vdid = $vd->ID;
					$vdname = $vd->Name;
					$vdNode = new MRUTreeNode($vd->LDImg, "Virtual Disk" . " ". $vdid . ": (" . $vdname . ")", "tip",
						$this->getDetailUrl(Target::getIndependentVDPage . "&ID=" . $vdid . "&HBAID=" . $hbaid), $vdid,
						MRUTreeNodeType::VD_LEAF,$hbaid);
					$this->setNodeExpandInfo($vdNode);
					$vdsNotOnDgNode->addChild($vdNode);
					if ($vdNode->getExpandTypeIndex() == EXPAND_TYPE_EXPAND) {
						foreach ($vd->Adapters as $adapter)
						{
							foreach ($adapter->HDs as $hd)
							{
								$pdid = $hd->ID;
								$hdNode = new MRUTreeNode(HdStatus::HD_STATUS_ASSIGNED_IMG, "Physical Disk" . " ". $pdid, "tip",
									$this->getDetailUrl(Target::getHdDetail . "&ID=" . $pdid . "&HBAID=" . $hbaid), $pdid + $vdid*128,
									MRUTreeNodeType::HDONVD_LEAF,$hbaid);
								$this->setNodeExpandInfo($hdNode);
								$vdNode->addChild($hdNode);
							}
						}
					}
				}
			}
		}
	}
	
	private function generateVDOnly($hbaid, $adpNode)
	{
		$smarty = $this->smarty;
		
		$vdList = new CtnLDList();
		$vdList->setAdapterID($hbaid);
		$vdList->toGetLDInfo();
		$vdList->toGetLDStatus();
		$vdList->toGetBlockInfo();
		$vdList->toGetHDInfo();
		$vdList->smartyAssign($smarty);
		$vdList->initContainer();
		$allvds = $vdList->getInfos();
		
		$vdsNotOnDg = array();
		foreach ($allvds as $vd)
		{
			if($vd->AdapterID == $hbaid)
			{
				$vdsNotOnDg[] = $vd;
			}
		}
		
		$vdsNotOnDgNode = new MRUTreeNode("", "Virtual Disks", "tip", "", $hbaid,
			MRUTreeNodeType::VD_TITLE_LEAF,$hbaid);
		$this->setNodeExpandInfo($vdsNotOnDgNode);
		if (! $vdsNotOnDg) {
			$vdsNotOnDgNode->cannotExpand();
		}
		else {
			if ($vdsNotOnDgNode->getExpandTypeIndex() == EXPAND_TYPE_CANNOTEXPAND) {
				$vdsNotOnDgNode->expand();
			}
		}
		$adpNode->addChild($vdsNotOnDgNode);
		if ($vdsNotOnDgNode->getExpandTypeIndex() == EXPAND_TYPE_EXPAND) {
			foreach ($vdsNotOnDg as $vd)
			{
				$vdid = $vd->ID;
				$vdname = $vd->Name;
				$vdNode = new MRUTreeNode($vd->LDImg, "Virtual Disk" . " ". $vdid . ": (" . $vdname . ")", "tip",
					$this->getDetailUrl(Target::getIndependentVDPage . "&ID=" . $vdid . "&HBAID=" . $hbaid), $vdid,
					MRUTreeNodeType::VD_LEAF,$hbaid);
				$this->setNodeExpandInfo($vdNode);
				$vdsNotOnDgNode->addChild($vdNode);
				if ($vdNode->getExpandTypeIndex() == EXPAND_TYPE_EXPAND) {
					foreach ($vd->Adapters as $adapter)
					{
						foreach ($adapter->HDs as $hd)
						{
							$pdid = $hd->ID;
							$hdNode = new MRUTreeNode(HdStatus::HD_STATUS_ASSIGNED_IMG, "Physical Disk" . " ". $pdid, "tip",
								$this->getDetailUrl(Target::getHdDetail . "&ID=" . $pdid . "&HBAID=" . $hbaid), $pdid + $vdid*128,
								MRUTreeNodeType::HDONVD_LEAF,$hbaid);
							$this->setNodeExpandInfo($hdNode);
							$vdNode->addChild($hdNode);
						}
					}
				}
			}
		}
	}
	
	private function generateAdapter($hbaid, $adpNode)
	{
		$smarty = $this->smarty;
		
		$adpFeature = AdapterFeature::getInstance($hbaid);
		if($adpFeature->supportDG)
		{
			$this->generateDG($hbaid, $adpNode);
			$this->generateForeignVD($hbaid, $adpNode);
		}
		else 
		{
			$this->generateVDOnly($hbaid, $adpNode);
		}
		
		$hdList = new CtnHdList();
		$hdList->setAdapterID($hbaid);
		$hdList->toGetHdInfo();
		$hdList->toGetHdFreeInfo();
		$hdList->toGetSpareInfo();
		$hdList->smartyAssign($smarty);
		$hdList->initContainer();
		$hds = $hdList->getInfos();
		
		//
		$pdNodes = new MRUTreeNode("", "Physical Disks", "tip", "", $hbaid,
				MRUTreeNodeType::HD_TITLE_LEAF,$hbaid);
		$this->setNodeExpandInfo($pdNodes);
		if (! $hds) {
			$pdNodes->cannotExpand();
		}
		else {
			if ($pdNodes->getExpandTypeIndex() == EXPAND_TYPE_CANNOTEXPAND) {
				$pdNodes->expand();
			}
		}
		$adpNode->addChild($pdNodes);
		if($pdNodes->getExpandTypeIndex() == EXPAND_TYPE_EXPAND)
		{			
			foreach ($hds as $hd)
			{
				$pdid = $hd->ID;
				$hdNode = new MRUTreeNode($hd->HDImg, "Physical Disk" . " ". $pdid, "tip", 
					$this->getDetailUrl(Target::getHdDetail . "&ID=" . $pdid . "&HBAID=" . $hbaid), $pdid,
					MRUTreeNodeType::HD_LEAF,$hbaid);
				$this->setNodeExpandInfo($hdNode);
				$pdNodes->addChild($hdNode);
			}	
		}
		
		$encList = new CtnEnclList();
		$encList->setAdapterID($hbaid);
		$encList->toGetEnclInfo();
		$encList->toGetEnclPMInfo();
		$encList->toGetEnclExpanderInfo();
		$encList->smartyAssign($smarty);
		$encList->initContainer();
		$enclosures = $encList->getInfos();
		
		if (sizeof($enclosures)) {
			$encNodes = new MRUTreeNode("", "Enclosures", "tip", "", $hbaid,
					MRUTreeNodeType::ENC_TITLE_LEAF,$hbaid);
			$this->setNodeExpandInfo($encNodes);
			/*
			if (! $enclosures) {
				$encNodes->cannotExpand();
			}
			else {
				if ($encNodes->getExpandTypeIndex() == EXPAND_TYPE_CANNOTEXPAND) {
					$encNodes->expand();
				}
			}
			*/
			$adpNode->addChild($encNodes);
			if($encNodes->getExpandTypeIndex() == EXPAND_TYPE_EXPAND)
			{	
				foreach ($enclosures as $enc)
				{
					$encid = $enc->ID;
					$encNode = new MRUTreeNode(TreeImg::Enclosure , "Enclosure" . " ". $encid, "tip", 
						$this->getDetailUrl(Target::getEnclDetail . "&ID=" . $encid . "&HBAID=" . $hbaid), $encid,
						MRUTreeNodeType::ENC_LEAF,$hbaid);
					$this->setNodeExpandInfo($encNode);
					$encNodes->addChild($encNode);
				}
			}
		}
		$bbuList = new CtnBBUDetail();
		$bbuList->setAdapterID($hbaid);
		$bbuList->toGetBBUInfo();
		$bbuList->smartyAssign($smarty);
		$bbuList->initContainer();
		$bbu = $bbuList->getInfos();
		if ($bbu){
			$bbuid = $bbu->ID;
			$bbuNodes = new MRUTreeNode(TreeImg::BBU, "Battery Backup Unit", "tip",
					//TODO
					$this->getDetailUrl(Target::getBBUSubPage . "&HBAID=" . $hbaid), $bbuid,
					MRUTreeNodeType::BBU_LEAF,$hbaid);
			$this->setNodeExpandInfo($bbuNodes);
			//if ($adpNode->getExpandTypeIndex() == EXPAND_TYPE_EXPAND) {
				$adpNode->addChild($bbuNodes);
			//}
		}
	}
	
	private function generateTree()
	{
		$smarty = $this->smarty;
		
		$rootNode = new MRUTreeNode(TreeImg::System ,"System","tip",
			"JumpPage.php?Target=getSystemSubPage",0,MRUTreeNodeType::SYSTEM_LEAF);
		//$rootNode->expand();
		//$this->setNodeExpandInfo($rootNode);		
		
		//add adapter...
		$HBAList = new CtnHBAList();
		$HBAList->toGetHBAInfo();
		$HBAList->smartyAssign($smarty);
		$HBAList->initContainer();
		$hbalist = $HBAList->getInfos();
//		
//		$hbasNode = new MRUTreeNode("" ,"Adapters","tip","",0,MRUTreeNodeType::ADAPTER_TITLE_LEAF);
//		$rootNode->addChild($hbasNode);
//		$this->setNodeExpandInfo($hbasNode);
//		if (! $hbalist) {
//			$hbasNode->cannotExpand();
//		}
//		
//		if($hbasNode->getExpandTypeIndex() == EXPAND_TYPE_EXPAND)
//		{
			foreach ($hbalist as $hbaInfo)
			{
				$hbaId = $hbaInfo->ID;
				$node = 
					new MRUTreeNode(TreeImg::Adapter ,"Adapter" . " " . $hbaId,
						"tip",
						$this->getDetailUrl(Target::getHBADetail . "&ID=" . $hbaId. "&HBAID" . $hbaId),
						$hbaId,MRUTreeNodeType::ADAPTER_LEAF);
				$this->setNodeExpandInfo($node);
				$rootNode->addChild($node);
				//$hbasNode->addChild($node);
				if($node->getExpandTypeIndex() != EXPAND_TYPE_UNEXPAND)
				{
					$this->generateAdapter($hbaId, $node);
				}
			}
//		}
		
		//get
		DrawTree($rootNode, $smarty);
	}
	
	private function getDetailUrl($paras)
	{
		//return "$paras";
		return PHPPageName::TargetPageName . "?Target=" . $paras;
	}
}

?>