<?php
//include_once("PageDisplayer.class.php");

class PgBoisFlashDisplayer extends PageDisplayer
{
	protected function initPage()
	{
		$id = $this->getAdapterID();
		$type = getRequestPara("type");
		
		//handle download
		if (getRequestPara("downloadFlash")) {
			$filepath = "../db/" . session_id() . "_" . FlashAction::FLASH_DOWNLOAD . "_" . $type;
			
			$apiCmd = new XMLAPICommand();
			$apiCmd->setCommand(XMLAPICommand::MV_Flash_Option);
			$apiCmd->setCommandPara('AdapterID', $id);
			$apiCmd->setCommandPara('Actions', FlashAction::FLASH_DOWNLOAD);
			$apiCmd->setCommandPara('Type', $type);
			$apiCmd->setCommandPara('filepath', $filepath);
			$apiCmd->issueCommand();
			
			if ($apiCmd->getResult()->RetVal . "" == 0)
			{
				//begin send file to client
				$fileName = gettext("BINFILE") . date("Ymd") . ".bin";
				$file_size = filesize($filepath);
				header("Content-Type: application/octet-stream");
				header("Content-Type: application/download");
				header("Content-Disposition: attachment; filename=$fileName;");
				header("Content-transfer-encoding: binary");
				header("Content-length: $file_size");
				readfile($filepath);
				unlink($filepath);
			}
			else 
			{
				//TODO handle error
				//print "internal error";
			}
			
			return;
		}
		
		//handle upload
		$this->setPageName(Target::BiosFlashPage . ".tpl");
		$smarty = $this->smarty;
		$filepath = "";
		$fileMaxSize = 192 * 1024;		
		if (getRequestPara("uploadFile") || getRequestPara("uploadFlash"))
		{
			if (isset($_FILES['boisFile']) && $_FILES['boisFile']["name"] != "")
			{
				$filepath = $_FILES["boisFile"]["tmp_name"];
				$size = $_FILES["boisFile"]["size"];
				
				if ($size > $fileMaxSize)
				{
					$smarty->assign("flashResult", FlashResult::FLASH_FILETOOLARGE);
					return;
				}
			}
				
			$boisVersion = "";
			$VenID = "";
			$DevID = "";
			
			//get file bios version
			$apiCmd = new XMLAPICommand();
			$apiCmd->setCommand(XMLAPICommand::MV_BIOS_Version);
			$apiCmd->setCommandPara('filepath', $filepath);
			$apiCmd->issueCommand();

			$xmlData = $apiCmd->getResult();
			if ($xmlData->RetVal . "" == 0) //if successfully
			{
				$VerMajor = 0;
				$VerMinor = 0;
				$VerOEM = 0;
				$VerBuild = 0;
				
				if (isset($xmlData->BIOSInfo))
				{
					foreach ($xmlData->BIOSInfo as $boisInfo)
					{
						if (isset($boisInfo->BIOSVersion)) {
							foreach ($boisInfo->BIOSVersion as $bsVersion)
							{
								foreach ($bsVersion->VerMajor as $version)
								{
									$VerMajor = trim($version);
								}
								foreach ($bsVersion->VerMinor as $version)
								{
									$VerMinor = trim($version);
								}
								foreach ($bsVersion->VerOEM as $version)
								{
									$VerOEM = trim($version);
								}
								foreach ($bsVersion->VerBuild as $version)
								{
									$VerBuild = trim($version);
								}
							}
						}
						
						if (isset($boisInfo->VenID)) {
							$VenID = strtoupper(trim($boisInfo->VenID));
						}
						if (isset($boisInfo->DevID)) {
							$DevID = strtoupper(trim($boisInfo->DevID));
						}
					}
				}
				
				if ($VerMajor || $VerMinor || $VerOEM || $VerBuild)
				{
					$boisVersion = $VerMajor . "." . $VerMinor . "." . $VerOEM . "." . $VerBuild;
					$smarty->assign("boisVersion", $boisVersion);
					$smarty->assign("DevID", $DevID);
					$smarty->assign("VenID", $VenID);
					$smarty->assign("HBAID", $id);
				}
			} else {  //get BIOS version failed
				$smarty->assign("flashResult", FlashResult::FLASH_GETVERSIONFAILED );
			}

			$flashSuccess = 0;
			//flash BIOS
			if (file_exists($filepath) && getRequestPara("uploadFlash"))
			{
				//check versions
				//check dev id
				//check vendor id
				$HBA = HBAFactory::getInstance($id);

				if ($DevID == strtoupper(dechex($HBA->getDevID()))
					&& $VenID == strtoupper(dechex($HBA->getVenID())))
				{
					$apiCmd = new XMLAPICommand();
					$apiCmd->setCommand(XMLAPICommand::MV_Flash_Option);
					$apiCmd->setCommandPara('AdapterID', $id);
					$apiCmd->setCommandPara('Actions', FlashAction::FLASH_UPLOAD);
					$apiCmd->setCommandPara('Type', $type);
					$apiCmd->setCommandPara('filepath', $filepath);
					$apiCmd->issueCommand();
					
					if ($apiCmd->getResult()->RetVal . "" == 0) {
						$flashSuccess = FlashResult::FLASH_SUCCESS ;
					}
					else {
						$flashSuccess = FlashResult::FLASH_UPLOADFAILED ;
					}
				}
				else 
				{
					$flashSuccess = FlashResult::FLASH_INVALIDFILE ;
				}
				
				$smarty->assign("flashResult", $flashSuccess);
			}
			
			//always remove the file after operations
			if (file_exists($filepath) && trim($filepath) !== "") {
				unlink($filepath);
			}
		}
	}
}
?>