<?php
//include_once("PageDisplayer.class.php");

class PgCreate2Displayer extends PageDisplayer
{
	protected function initPage()
	{
		if(!getSessionPara('isAdmin'))
		{
			$this->displayDefaultPage(Target::LdListPage);
			return;
		}
		
		$smarty = $this->smarty;
		
		//get request para
		$RaidMode = getRequestPara('RaidMode');
		$LDSize = getRequestPara('LDSize');
		$LDName = trim(getRequestPara('LDName'));
		$InitType = getRequestPara('InitType');
		$StripeSize = getRequestPara('StripeSize');
		$SectorSize = getRequestPara('SectorSize');
		$WriteCache = getRequestPara('WriteCache');
		$ReadCache = getRequestPara('ReadCache');
		$GBRounding = getRequestPara('GBRounding');
		$ParityDisk = getRequestPara('NumOfParityDisk');
		$CancelAlert = gettext(AlertMsg::CREATE_CANCEL)."?";
		
		//set default name
		if (trim($LDName) == "") {
			$ldlist = new LDList();
			$ldlist->setAdapterID($this->getAdapterID());
			$ldlist->toGetLDInfo();
			$count = sizeof($ldlist->getBaseClasses()) + 1;
			$RaidType = "";
			switch ($RaidMode)
			{
				case RAIDMode::LD_MODE_RAID0 : $RaidType = "R0"; break;
				case RAIDMode::LD_MODE_RAID1 : $RaidType = "R1"; break;
				case RAIDMode::LD_MODE_RAID1E : $RaidType = "R1E"; break;
				case RAIDMode::LD_MODE_RAID5 : $RaidType = "R5"; break;
				case RAIDMode::LD_MODE_RAID6 : $RaidType = "R6"; break;
				case RAIDMode::LD_MODE_JBOD : $RaidType = "JBOD"; break;
				case RAIDMode::LD_MODE_RAID10 : $RaidType = "R10"; break;
				case RAIDMode::LD_MODE_RAID50 : $RaidType = "R50"; break;
				case RAIDMode::LD_MODE_RAID60 : $RaidType = "R60"; break;
			}
			$LDName = "VD_" . $RaidType ."_" .$count;
		}
		
		//default raid mode
		if ($RaidMode == null) {
			$RaidMode = RAIDMode::LD_MODE_RAID1 ;
		}
		
		if ($StripeSize == null) {
			$StripeSize = LDStripeSize::StripeSize64K ;
		}
		$HDs = getRequestPara('HDs');
		if ($HDs == null) {
			$HDIDs = array();
		}
		else {
			$HDIDs = explode(" ",$HDs);
			foreach ($HDIDs as $HD)
			{
				if (trim($HD) === "") {
					unset($HD);
				}
			}
			//set max size
			$container = new CtnCreateLDMaxSize();
			$container->setAdapterID($this->getAdapterID());
			$container->smartyAssign($smarty);
			foreach ($HDIDs as $HD)
			{
				$container->addHDID($HD);
			}
			$container->setRaidMode($RaidMode);
			if ($RaidMode == RAIDMode::LD_MODE_RAID6 || $RaidMode == RAIDMode::LD_MODE_RAID60 ) {
				$container->setNumParityDisk($ParityDisk);
			}
			$container->initContainer();
		}
			
		$sysFeature = AdapterFeature::getInstance($this->getAdapterID());
		
    	$quickInit = gettext(LdBgaStatus::LD_BGA_INIT_QUICK_STR);
    	$bgInit = gettext(LdBgaStatus::LD_BGA_INIT_BACK_STR);
    	$fgInit = gettext(LdBgaStatus::LD_BGA_INIT_FORE_STR);
    	$noInit = gettext("No Initialization");
		
		if ($RaidMode == RAIDMode::LD_MODE_RAID0)
		{
			$InitOptions = 
	    			array(
	    				InitType::INIT_QUICK=>$quickInit,
	    				InitType::INIT_NONE =>$noInit
	    			);
		}
		else
		{
			if ($sysFeature->supportForegroundInit) {
				$InitOptions = 
		    			array(
		    				InitType::INIT_QUICK=>$quickInit,
		    				InitType::INIT_FULLBACKGROUND =>$bgInit,
		    				InitType::INIT_FULLFOREGROUND =>$fgInit,
		    				InitType::INIT_NONE =>$noInit
		    			);
			} else {
				$InitOptions = 
		    			array(
		    				InitType::INIT_QUICK=>$quickInit,
		    				InitType::INIT_FULLBACKGROUND =>$bgInit,
		    				InitType::INIT_NONE =>$noInit
		    			);
			}
		}
		
		//write cache
		$wBack = gettext("Write Back(Performance)");
	    $wThru = gettext("Write Through(Reliable)");
    	    	    	
    	if (!isset($WriteCache)) {
			$WriteCache = LDCacheMode::WRITEBACK_ENABLE ;
		}
		$wCacheOptions = 
			array(
				LDCacheMode::WRITEBACK_ENABLE=>$wBack,
				LDCacheMode::WRITETHRU_ENABLE =>$wThru   //default value
			);
					
		//read cache	
    	$rAhead = gettext("Read Ahead");
    	$rNone = gettext("No Read Ahead");
    	
		if (!isset($ReadCache)) {
			$ReadCache = LDCacheMode::LOOKAHEAD_ENABLE ;
		}
		$rCacheOptions = 
			array(
				0 =>$rNone,
				LDCacheMode::LOOKAHEAD_ENABLE =>$rAhead   //default value
			);

		//read cache	
    	$None = gettext("None");
    	
    	//gb rounding
		if (!isset($GBRounding)) {
			$GBRounding = Rounding_Scheme::ROUNDING_SCHEME_1GB ;
		}
		$GBRoundingOptions = 
			array(
				Rounding_Scheme::ROUNDING_SCHEME_NONE  => $None, 
				Rounding_Scheme::ROUNDING_SCHEME_1GB  => "1G", //default value 
				Rounding_Scheme::ROUNDING_SCHEME_10GB   => "10G"
			);

		if ($RaidMode == RAIDMode::LD_MODE_RAID50
			 || $RaidMode == RAIDMode::LD_MODE_RAID5 
			 || $RaidMode == RAIDMode::LD_MODE_RAID6 
			 || $RaidMode == RAIDMode::LD_MODE_RAID60 )
		{
			$stripeOptions = 
				array(
					LDStripeSize::StripeSize64K =>LDStripeSize::StripeSize64KStr
				);	
		}
		else {
			$stripeOptions1 = 
				array(
					LDStripeSize::StripeSize16K =>LDStripeSize::StripeSize16KStr,
					LDStripeSize::StripeSize32K =>LDStripeSize::StripeSize32KStr,
					LDStripeSize::StripeSize64K =>LDStripeSize::StripeSize64KStr,
					LDStripeSize::StripeSize128K =>LDStripeSize::StripeSize128KStr
				);
				
			$stripeOptions2 = 
				array(
					LDStripeSize::StripeSize256K =>LDStripeSize::StripeSize256KStr,
					LDStripeSize::StripeSize512K =>LDStripeSize::StripeSize512KStr,
					LDStripeSize::StripeSize1024K =>LDStripeSize::StripeSize1024KStr 
				);
			
			if (1) {//!$hba->supportBigStripe()
				$stripeOptions = $stripeOptions1;
			} else {
				$stripeOptions = ($stripeOptions1 + $stripeOptions2);
			}
		}
		
		/*
		$sectorOptions = 
			array(
				LDSectorSize::SectorSize512B =>LDSectorSize::SectorSize512BStr,
				LDSectorSize::SectorSize1024B =>LDSectorSize::SectorSize1024BStr,
				LDSectorSize::SectorSize2048B =>LDSectorSize::SectorSize2048BStr,
				LDSectorSize::SectorSize4096B =>LDSectorSize::SectorSize4096BStr
			);
			$smarty->assign("sectorOptions",$sectorOptions);
		*/
		
		$smarty->assign("InitOptions",$InitOptions);
		
		$smarty->assign("wCacheOptions",$wCacheOptions);
		$smarty->assign("rCacheOptions",$rCacheOptions);
		$smarty->assign("stripeOptions",$stripeOptions);
		$smarty->assign("GBRoundingOptions",$GBRoundingOptions);
			
		$smarty->assign("HBAID", $this->getAdapterID());	
		$smarty->assign("RaidMode", $RaidMode);	
		$smarty->assign("LDSize", $LDSize);
		$smarty->assign("LDName", $LDName);	
		$smarty->assign("InitType", $InitType);	
		$smarty->assign("StripeSize", $StripeSize);	
		$smarty->assign("SectorSize", $SectorSize);	
		$smarty->assign("WriteCache", $WriteCache);	
		$smarty->assign("ReadCache", $ReadCache);
		$smarty->assign("GBRounding", $GBRounding);
		$smarty->assign("RaidModeStr", RAIDMode::GetRAIDModeStr($RaidMode));	
		$smarty->assign("HDIDs", $HDs);
		$smarty->assign("ParityDisk", $ParityDisk);
		$smarty->assign("CancelAlert", $CancelAlert);
		
		$this->setPageName(Target::CreatePage2 . ".tpl");
	}
}
?>